
// Demo program for file renaming macros
// by LD Blake, June 2016



#define __STDC_WANT_LIB_EXT2__ 1
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <shlwapi.h>
#include <lmcons.h>

// the rename algorithm
#include "..\renamer.h"

// include library in search path
#ifdef _WIN64
#pragma comment(lib, "..\\ren64.lib")
#else
#pragma comment(lib, "..\\ren32.lib")
#endif


int _cdecl main(void)
  {
    PCHAR   line    = 0;    // curent line buffer  
    size_t  lsize   = 0;    // buffer length
    PCHAR   ptr     = 0;    // line end
    PCHAR   from    = 0;
    PCHAR   wcard   = 0;
    char    to[MAX_PATH] = {0};


    // enable mouse wheel scrolling
    {
      DWORD   mode;  // mode setting
      HANDLE  csi;   // console handle

      csi = GetStdHandle(STD_INPUT_HANDLE);
      
      GetConsoleMode(csi, &mode);
      SetConsoleMode(csi, mode & ~ENABLE_MOUSE_INPUT | ENABLE_PROCESSED_INPUT);
      setvbuf(stdout, NULL, _IONBF, 0);
      setlocale(LC_ALL, "");
      SetConsoleCP(GetACP());
      SetConsoleOutputCP(GetACP());
    }

    printf("Renamer demo\n");
    printf("Instructions in RenamerMacros.txt\n");
    printf("\nDo not include paths, filenames only\n\n");

    while(1)
      {
        printf("Old Name : ");
        if(getline(&line, &lsize, stdin) < 1)
          break;
        
        ptr = strchr(line, '\r');
        if(ptr) *ptr = 0;
        ptr = strchr(line, '\n');
        if(ptr) *ptr = 0;

        from = _strdup(line);

        printf("Wildcard : ");
        if(getline(&line, &lsize, stdin) < 1)
          break;
        
        ptr = strchr(line, '\r');
        if(ptr) *ptr = 0;
        ptr = strchr(line, '\n');
        if(ptr) *ptr = 0;

        wcard = _strdup(line);

        *to = 0;

        if(RenameFile(from, wcard, to))
          printf("New Name : %s\n\n", to);
        else
          printf("Invalid operation\n\n");

        free(from);
        free(wcard);
      }
    return 0;
  }









